!      
 member
 include('cWatchF.inc'),once
 Map
   WFSubClass(unsigned,unsigned,unsigned,long),long,pascal   
   WatchFileProc(long),long,pascal
 end

StophWndQ byte

hwndQ     queue
hWnd        ulong
wMsg        long
cwThread    long
SavedProc   long
          end
InvalidHdlValue EQUATE(-1)
FILE_CHANGE_ALL EQUATE(FILE_NOTIFY_CHANGE_SIZE+ |
                       FILE_NOTIFY_CHANGE_LAST_WRITE+|
                       FILE_NOTIFY_CHANGE_LAST_ACCESS)
Return:Benign   EQUATE(0)
Return:Fatal    EQUATE(3)
! ***************************************************************************************
WFSubClass procedure(unsigned hWnd,unsigned wMsg,unsigned wParam,long lParam)
SaveGrp like(hwndQ)
  code
  if StophWndQ then return(1).
  hwndQ.hWnd=hWnd
  get(hwndQ,hwndQ.hWnd)
  If errorcode() then return(1).
  SaveGrp=hwndQ
  if SaveGrp.wMsg=wMsg 
    post(EVENT:DIR_CHANGE,,SaveGrp.cwThread)
  end
  return CallWindowProc(SaveGrp.SavedProc,hWnd,wMsg,wParam,lParam)
! ***************************************************************************************
WatchFileProc procedure(long lpWaitStruct) !    
locWaitStruct like(WaitStruct)
Infinite      EQUATE(-1)
Wait_object_0 EQUATE(0)
 code
 memcpy(address(locWaitStruct),lpWaitStruct,size(WaitStruct))
 loop
    if WaitForMultipleObjects(2,address(locWaitStruct.hNotification),0,Infinite)=Wait_object_0  
       SendMessage(locWaitStruct.hWnd,locWaitStruct.wMsg,0,0)
       FindNextChangeNotification(locWaitStruct.hNotification)
       cycle
    end
    break
 end
 return 0
! ***************************************************************************************
cWatchFile.Init procedure(ulong pCWThread,*string pTargetDir)
SavedProc     long,auto
ThreadID      long,auto
cstrTargetDir cstring(FILE:MaxFilePath)
 code
 clear(SELF)
 cstrTargetDir=clip(pTargetDir)
 self.WFStruct.wMsg=RegisterWindowMessage(cstrTargetDir)
 settarget(,pCWThread)
 self.WFStruct.hWnd=0{PROP:handle}
 SavedProc=0{PROP:WndProc}
 StopHwndQ=True
 hwndQ.hWnd=self.WFStruct.hWnd
 hwndQ.wMsg=self.WFStruct.wMsg
 hwndQ.cwThread=pCWthread
 hwndQ.SavedProc=SavedProc
 add(hwndQ,hwndQ.hWnd)
 StopHwndQ=False
 0{PROP:WndProc}=address(WFSubClass)
 settarget()
 self.WFStruct.hEvent=CreateEvent(0,1,0,0)
 if ~self.WFStruct.hEvent then self.Kill; return(Return:Fatal).
 self.WFStruct.hNotification=FindFirstChangeNotification(cstrTargetDir,TRUE,FILE_CHANGE_ALL)
 if self.WFStruct.hNotification=InvalidHdlValue then self.Kill; return(Return:Fatal).
 self.hThread=CreateThread(0,256,address(WatchFileProc),address(self.WFStruct),1,ThreadID)
 if ~self.hThread then self.Kill; return(Return:Fatal).
 return(Return:Benign)
! ***************************************************************************************
cWatchFile.Reset procedure 
ThreadID long,auto
 code
 if self.hThread 
    CloseHandle(self.hThread)
    clear(self.hThread)
  end
  if self.WFStruct.hNotification
     FindNextChangeNotification(self.WFStruct.hNotification)
     self.hThread=CreateThread(0,256,address(WFSubClass),address(self.WFStruct),0,ThreadID)
  end
! ***************************************************************************************  
cWatchFile.Kill procedure
 code
 if self.WFStruct.hWnd 
    StopHwndQ=true
    hwndQ.hWnd=self.WFStruct.hWnd 
    get(hwndQ,hwndQ.hWnd)
    if ~errorcode() 
        0{PROP:WndProc}=hwndQ.SavedProc
        delete(hwndQ)
    end
    StopHwndQ=false
    clear(self.WFStruct.hWnd)
 end
 if self.hThread and self.WFStruct.hEvent 
    SetEvent(self.WFStruct.hEvent)
    CloseHandle(self.hThread)
    CloseHandle(self.WFStruct.hEvent)
    clear(self.hThread)
    clear(self.WFStruct.hEvent)
 end
 if self.WFStruct.hNotification 
    FindCloseChangeNotification(self.WFStruct.hNotification)
    clear(self.WFStruct.hNotification)
 end
! ***************************************************************************************  
cWatchFile.TakeEvent procedure
 code
 if event()=EVENT:DIR_CHANGE then return(1).
 return(0)
 